#<profile4xi profile = "20" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "valuefunction4xi.py">
#<abstract4xi abstract = "providing function ValueFunction4Xi"/>
#<refer4xi reference = "sharedctypes.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "whereas value4xi.py - not this module - provides the class Value4Xi"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ValueFunction4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import weakref 
import array
import queue
from traceback import format_exc
import copyreg
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Source ones
    from multiprocessing.sharedctypes import Value
except:
    print("valuefunction4xi.py: *** failed in from multiprocessing.sharedctypes import Value ***")   
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from examine4xi import examine4xi 
from rawvalue4xi import RawValue4Xi
from rlock4xi import RLock4Xi
from synchronized_function4xi import synchronized_function4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "ValueFunction4Xi" usage = "
#
#   __init__.py:
#       return ValueFunction4Xi(typecode_or_type, *args, **kwds) 
#
#">
#<note4xi note = "
#    Value4Xi is the class defined in value4xi.py, 
#    whereas this module defines the function name changed to ValueFunction + 4Xi"/> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ValueFunction4Xi(typecode_or_type, *args, lock=None):
    '''
    ValueFunction4Xi function returns a synchronization wrapper for a Value 
    '''
           
    # -------------------------------------------------------------------------------------    
    # 
    # -------------------------------------------------------------------------------------  
    class2print = "ValueFunction4Xi"
    method2print = "ValueFunction4Xi"

    message2print = "{started" + "; ValueFunction4Xi-started: " + str(ValueFunction4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function ValueFunction4Xi at 0x00000000037BFBF8>
        
    message2print = "{passed" + "; typecode-or-type-passed-to-ValueFunction4Xi: " + str(typecode_or_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #1 i <-- integer
    #2 <class 'ctypes.c_double'>  
    #3 <class '__main__.Point4Xi'> 

    message2print = "{passed" + "; lock-passed-to-ValueFunction4Xi: " + str(lock) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #1 None
    
    arguments = enumerate(args)
    message2print = "{passed" + "; arguments-passed-to-ValueFunction4Xi: " + str(arguments) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #1 <enumerate object at 0x0000000003AABCF0>    
    #2 <enumerate object at 0x000000000392F798>
    
    message2print = "{passed" + "; lock-passed-to-ValueFunction4Xi: " + str() + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # 
    
    if examine4xi(class2print, method2print):  
    
        # -------------------------------------------------------------------------------------    
        # StepOriginal
        # -------------------------------------------------------------------------------------             
        message2print = "{(Step 2/6b) performing" + "; Value-performing-by-ValueFunction4Xi: " + str(Value)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        #1 <function Value at 0x0000000002C33C80>
        
        lock2pass = lock
        value2return = None
        
        try:                 
            value2return = Value(typecode_or_type, *args, lock=lock2pass)
            
            message2print = "{(Step 2/6b) got" + "; value2return-got-by-ValueFunction4Xi: " + str(value2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            #1 <Synchronized wrapper for c_long(7)>
            
        except:
            message2print = "{(Step 2/6z) failed " + "; Value-failed-by-ValueFunction4Xi: " + str(Value)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            #2  <class 'ctypes.c_double'>
        finally: 
            message2print = "{(Step 2/6d) returning " + "; value2return-returning-by-ValueFunction4Xi: " + str(value2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            #1 <Synchronized wrapper for c_long(7)>
                
            return value2return
        
    else:        
                
        # -----------------------------------------------------------------------------------------    
        # 
        # ----------------------------------------------------------------------------------------- 
        message2print = "{passing" + "; typecode-or-type-passing-to-RawValue4Xi-by-ValueFunction4Xi: " + str(typecode_or_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
    
        object2xi = RawValue4Xi(typecode_or_type, *args)
        
        message2print = "{set" + "; object-set-by-ValueFunction4Xi to: " + str(object2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # c_long(7)               
        
        
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------     
        if lock is None:
            lock = RLock4Xi()
            
            message2print = "{set" + "; lock-set-by-ValueFunction4Xi to: " + str(lock)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
        
    
            
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------     
        if hasattr(lock, 'acquire'):
        
            message2print = "{asserted" + "; lock-asserted-by-ValueFunction4Xi: " + str(lock) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        else:
            message2print = "{yielded" + "; lock-yielded-by-ValueFunction4Xi: " + str(lock)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                    
            
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------     
        message2print = "{passing" + "; object-passing-to-synchronized-function4xi-by-ValueFunction4Xi: " + str(object2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
        message2print = "{passing" + "; lock-passing-to-synchronized-function4xi-by-ValueFunction4Xi: " + str(lock) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                           
        message2print = "{returning" + "; synchronized-function4xi-function-returning-by-ValueFunction4Xi: " + str(synchronized_function4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
            
            
        return synchronized_function4xi(object2xi, lock)
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   None
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                              
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of valuefunction4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
